/* $Id: globals.h,v 1.5 2006/01/16 20:55:05 arved Exp $ */

#ifndef GLOBALS_H
#define GLOBALS_H

#define TYPE_VOID 0
#define TYPE_BOOL 1
#define TYPE_INT  2
#define TYPE_PROC 3

#define NODEKIND_STMT 1
#define NODEKIND_EXPR 2

/* Statement kinds */
#define KIND_IF     1
#define KIND_WHILE  2
#define KIND_ASSIGN 3
#define KIND_READ   4
#define KIND_WRITE  5
/* Expression */
#define KIND_OP     6
#define KIND_CONST  7
#define KIND_ID     8


#define MAXCHILDREN 3

typedef struct treeNode
{
	int kind; /* KIND StmtKind or ExpKind */
	int val;
	int op;
	char * name;
	struct treeNode * child[MAXCHILDREN];
	struct treeNode * sibling;
	int type; /* for type checking of exps */
	int arr_offset;
} TreeNode;

#endif
