/* $Id: main.c,v 1.14 2006/01/18 09:10:49 arved Exp $ */

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "parser.h"
#include "codegen.h"
#include "symtab.h"
#include "syntree.h"

int main(int argc, char* argv[])
{
	symtabinit();
	if ( argc == 1) {
       		printf("sc: no input files\n");
       		return -1;
 	}
    	int i;
   	FILE *inputfilep;
    	for (i=1; i <argc; i++) {
		num_lines=1;
        	char *inputfilename = argv[i];
        	char *dot= strrchr(inputfilename, '.');
        	char *listingfilename = malloc((strlen(inputfilename)+4)*(sizeof(char)));
        	char *tokenfilename = malloc((strlen(inputfilename)+4)*(sizeof(char)));
		char *asmfilename = malloc((strlen(inputfilename)+4)*(sizeof(char)));
        	if (dot) {
                	int length = dot - inputfilename;
			strlcpy(listingfilename,inputfilename, length+1);
			strlcpy(tokenfilename,inputfilename, length+1);
			strlcpy(asmfilename,inputfilename, length+1);
        	} else {
                	fprintf(stderr,"wrong file-extension?");
                	strlcpy(listingfilename, inputfilename, sizeof(inputfilename)+1);
                	strlcpy(tokenfilename, inputfilename, sizeof(inputfilename)+1);
			strlcpy(asmfilename, inputfilename, sizeof(inputfilename)+1);
        	}
       		strcat(listingfilename,".lis");
       		strcat(tokenfilename,".tok");
		strcat(asmfilename,".vm");

		fprintf(stderr,"Listingfile: %s\n", listingfilename);
        	inputfilep = freopen(inputfilename,"rb",stdin);
        	if (inputfilep == NULL) {
                	fprintf(stderr, "Could not open file %s\n", inputfilename);
                	exit(1);
        	}
        	listingfilep = fopen(listingfilename,"w+");
        	if (listingfilep == NULL) {
                	fprintf(stderr, "Could not open file %s\n", listingfilename);
                	exit(1);
        	}
       		tokenfilep = fopen(tokenfilename,"w+");
       		if (tokenfilep == NULL) {
               		fprintf(stderr, "Could not open file %s\n", tokenfilename);
               		exit(1);
       		}

		FILE *yyin = inputfilep;
		yyparse();
  		if(!erroroccured) {
			fprintf(listingfilep,"\nNo errors detected.\n");
               		fprintf(stdout,"No errors detected.\n");
#if 0
			fprintf(stderr,"\nSyntaxtree:\n============\n");
			printsyntree(savedTree);
#endif
			codegen(savedTree, asmfilename);
       		} else {
			if (errorcount == 1) {
				fprintf(listingfilep,"\n%d Error detected.\n", errorcount);
				fprintf(stdout,"%d Error detected.\n", errorcount);
			} else {
				fprintf(listingfilep,"\n%d Errors detected.\n", errorcount);
				fprintf(stdout,"%d errors detected.\n", errorcount);
			}

		}
	        fclose(inputfilep);
  		fclose(listingfilep);
        	fclose(tokenfilep);
		symtabfree();
		erroroccured = false;
		errorcount = 0;
	}
	return(0);
}
