/* $Id: parser.h,v 1.11 2006/01/17 21:03:52 arved Exp $ */

#ifndef PARSER_H
#define PARSER_H

/* Syntax tree */
static TreeNode * savedTree;

FILE *tokenfilep;
FILE *listingfilep;

int num_lines;

char *procname;

/* *** functions *** */

/* Syntax tree functions */

TreeNode *newNode(int kind);
TreeNode *createnodewchildren(int kind, TreeNode *child1, TreeNode *child2, TreeNode *child3);
TreeNode *createopnode(int kind, TreeNode *child1, TreeNode *child2, TreeNode *child3, int op, int type);

/* parser helper functions */

TreeNode *variable( char *sym_name, int arr_offset);

/* declaration checks if a variable is already declared and if not inserts
 * the a record into the symtab */
void declaration(char *sym_name, int type, int arr_sz, TreeNode *proctree);

/* context_check checks if sym_name is a record in the symtab and throws
 * an error otherwise */
void context_check( char *sym_name);

/* callstmt checks if the procedure exists and throws an error otherwise */
void callstmt(char *sym_name);

/* checkarraydecl checks if size is element of N */
void checkarraydecl(int size);

/* checkarray checks if arr_sz is < size of sym_name */
void checkarray(char *sym_name, TreeNode *arr_sz);

/* checks if both types are integers */
void checkoperand(TreeNode *node1, TreeNode *node2);

/* checks if both types are equal */
void checkassignment(TreeNode *node1, TreeNode *node2);

/* checks if type is not a procedure */
void checkwrite(TreeNode *node);

/* checks if condition is BOOL */
void checkexpr(TreeNode *node);

void yyerror(char *s);

#endif
