/* $Id: syntree.c,v 1.9 2006/01/17 21:10:45 arved Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include "globals.h"

TreeNode *newNode(int kind) {
	TreeNode *t = (TreeNode *) malloc(sizeof(TreeNode));
	int i;
  	if (t==NULL) {
    		fprintf(stderr,"newNode: Out of memory error\n");
	} else {
		t->sibling = NULL;
		for (i=0;i<MAXCHILDREN;i++)
			t->child[i] = NULL;
		t->name = NULL;
		t->val = 0;
		t->kind = kind;
		t->type = TYPE_VOID;
		t->arr_offset = 0;
	}
	return t;
}

void printnode(TreeNode *tree) {
	fprintf(stderr,"Node: %d\n", tree->kind);

	if (tree->name)
		fprintf(stderr,"	Name == %s\n",tree->name);
	if (tree->val)
		fprintf(stderr,"	Value == %d\n", tree->val);
	if (tree->op) {
		fprintf(stderr,"	Operation = %d\n", tree->op);
	}
	if (tree->arr_offset) {
		fprintf(stderr,"	Array Offset = %d\n", tree->arr_offset);
	}
}

void printsyntree(TreeNode *tree) {
	int i;
	if (tree == NULL) {
		fprintf(stderr,"ERROR: Empty tree!\n");
		return;
	}
	printnode(tree);
	for(i = 0; i <= 3; i++) {
		if(tree->child[i]) {
			fprintf(stderr,"->	child %d\n",i);
			printsyntree(tree->child[i]);
			fprintf(stderr,"<-	child %d\n",i);
		} else {
			//fprintf(stderr,"End of Children\n");
			break;
		}
	}
	if(tree->sibling) {
		fprintf(stderr,"Sibling: \n");
		printsyntree(tree->sibling);
	}
}
